"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var pact = require("@pact-foundation/pact");
var path = require("path");
var logHint = function (options) {
    return options.port ? "-port-" + options.port : '';
};
var applyDefaults = function (options) { return (__assign({ log: path.resolve(process.cwd(), 'pact/logs', options.consumer + "-" + options.provider + "-mockserver-interaction" + logHint(options) + ".log"), dir: path.resolve(process.cwd(), 'pact/pacts'), spec: 2, logLevel: 'warn', pactfileWriteMode: 'update' }, options)); };
var setupProvider = function (options) {
    var pactMock = new pact.Pact(options);
    beforeAll(function () { return pactMock.setup(); });
    afterAll(function () { return pactMock.finalize(); });
    afterEach(function () { return pactMock.verify(); });
    return pactMock;
};
// This should be moved to pact-js, probably
exports.getProviderBaseUrl = function (provider) {
    return provider.mockService
        ? provider.mockService.baseUrl
        : "http://" + provider.opts.host + ":" + provider.opts.port;
};
exports.pactWith = function (options, tests) {
    return describe("Pact between " + options.consumer + " and " + options.provider, function () {
        var pactTestTimeout = options.timeout || 30000;
        describe("with " + pactTestTimeout + " ms timeout for Pact", function () {
            var originalTimeout;
            beforeAll(function () {
                originalTimeout = jasmine.DEFAULT_TIMEOUT_INTERVAL;
                jasmine.DEFAULT_TIMEOUT_INTERVAL = pactTestTimeout;
            });
            afterAll(function () {
                jasmine.DEFAULT_TIMEOUT_INTERVAL = originalTimeout;
            });
            tests(setupProvider(applyDefaults(options)));
        });
    });
};
